﻿using System;
using System.Threading.Tasks;
using Tessa.Cards;
using Tessa.Cards.Extensions;
using Tessa.Extensions.WorkflowExamples.Shared.Workflow;
using Tessa.Workflow.Helpful;

namespace Tessa.Extensions.WorkflowExamples.Server.Workflow
{
    public sealed class WfeLoanStoreExtension : CardStoreExtension
    {
        #region Fields

        private readonly Guid startTileID = new Guid(0x755e8f5e, 0xa078, 0x4a19, 0xab, 0x47, 0xd1, 0xae, 0x8e, 0x14, 0x9f, 0x97); // 755e8f5e-a078-4a19-ab47-d1ae8e149f97

        #endregion

        #region Base Overrides

        /// <inheritdoc/>
        public override Task BeforeRequest(ICardStoreExtensionContext context)
        {
            var request = context.Request;

            if (!context.ValidationResult.IsSuccessful())
            {
                return Task.CompletedTask;
            }

            var card = request.Card;

            if (card.StoreMode == CardStoreMode.Insert
                && card.TryGetInfo()?.ContainsKey(WfeHelper.DisableAutoStartKey) != true)
            {
                var requestInfo = request.Info;
                requestInfo.SetWorkflowTileID(this.startTileID);
                requestInfo.SetWorkflowType(WorkflowEngineHelper.WorkflowEngineType);
            }

            return Task.CompletedTask;
        }

        #endregion
    }
}
